      $set ooctrl(+p) ooctrl(-f)
       
      ****************************************************************
      * Copyright (C) 1997-2001 Micro Focus International Ltd.	     *
      * All Rights Reserved.                                         *
      ****************************************************************
      *                                                              *
      * This program demonstrates how to read and update structures  *
      * in COBOL, passed via Java objects implementing the DataType  *
      * interface from mfcobol.lang.				     *
      *								     *
      *  Version History:                                            *
      *  1.0                        Created                          *
      *                                                              *
      ****************************************************************
       
      *>-----------------------------------------------------------
      *> Class description
      *>-----------------------------------------------------------
       class-id. RecordDemo
                 inherits from javabase.

       object section.
       class-control.
           RecordDemo is class "RecordDemo"
      *> OCWIZARD - start list of classes
           javabase is class "javabase"
      *> OCWIZARD - end list of classes
      *>---USER-CODE. Add any additional class names below.

           .

      *>-----------------------------------------------------------
       working-storage section. *> Definition of global data
      *>-----------------------------------------------------------

      *>-----------------------------------------------------------
       class-object.   *> Definition of class data and methods
      *>-----------------------------------------------------------
       object-storage section.

      *> OCWIZARD - start standard class methods
      *> OCWIZARD - end standard class methods

       end class-object.

      *>-----------------------------------------------------------
       object.         *> Definition of instance data and methods
      *>-----------------------------------------------------------
       object-storage section.

      *> OCWIZARD - start standard instance methods
      *> OCWIZARD - end standard instance methods

      *>---------------------------------------------------------------
      *> setDetails - Receive a customer record from Java and display
      *>              it prior to modifying the information and
      *>              returning.
       method-id. "setDetails".
       local-storage Section.
      *>---USER-CODE. Add any local storage items needed below.
       linkage Section.
       01 customerDetails.
         03 customerName       pic x(30).
         03 customerAddress    pic x(30).
         03 customerRef        pic 9(6).
       procedure division using by reference customerDetails.
	 add 1 to customerRef
       exit method.
       end method "setDetails".
      *>---------------------------------------------------------------


       end object.

       end class RecordDemo.
